import { html } from "@microsoft/fast-element";
import { staticallyCompose } from "../utilities/template-helpers.js";
/**
 * The template for {@link @microsoft/fast-foundation#FASTAvatar} component.
 * @public
 */
export function avatarTemplate(options = {}) {
    return html `
    <div
        class="backplate"
        part="backplate"
    >
        <a
            class="link"
            part="link"
            href="${x => (x.link ? x.link : void 0)}"
        >
            <slot name="media">${staticallyCompose(options.media)}</slot>
            <slot><slot>
        </a>
    </div>
    <slot name="badge"></slot>
    `;
}
