/**
 * Enumerates the data grid auto generated header options
 * default option generates a non-sticky header row
 *
 * @public
 */
export const GenerateHeaderOptions = {
    none: "none",
    default: "default",
    sticky: "sticky",
};
/**
 * Enumerates possible data grid cell types.
 *
 * @public
 */
export const DataGridCellTypes = {
    default: "default",
    columnHeader: "columnheader",
    rowHeader: "rowheader",
};
/**
 * Enumerates possible data grid row types
 *
 * @public
 */
export const DataGridRowTypes = {
    default: "default",
    header: "header",
    stickyHeader: "sticky-header",
};
/**
 * Class names for the data grid cell
 * @public
 */
export const DataGridCellTypeClass = {
    columnheader: "column-header",
    default: "",
    rowheader: "row-header",
};
/**
 * Roles for the data grid cell
 *
 * @public
 */
export const DataGridCellRole = {
    columnheader: "columnheader",
    rowheader: "rowheader",
    default: "gridcell",
};
